# -*- coding: utf-8 -*-
import cocos
from cocos.actions import *
import data
import pyglet

from mapsprite import MapSprite
import random
from math import sqrt
class BugSprite(MapSprite):
    """
    This is where the logic specific to a specific bug is created. For example
    see spin.
    """
    def __init__(self,*args,**kwds):
        MapSprite.__init__(self,*args,**kwds)
        self.health = 100
        self.speed  = 10
        self.mainPathIndex = 0
        self.ownPathIndex  = 0
        self.followMainPath = True
        self.xp = self.health / 5
        
    def setScaling(self,scale):
        self.health *= scale * 1.2
        self.speed  *= scale * 0.8
        if self.speed > 70: self.speed = 70
    def moveTo(self,x,y,dt):
        """
        Moves the bug in the direction of x,y at a rate in proportion to the
        speed of the bug.
        """
        xo,yo = self.position

        
        dx = x - xo
        dy = y - yo
        
        u_norm = sqrt(dx**2 + dy**2)
        
        s = self.speed * dt
        
        dxt = float(dx*s)/u_norm
        dyt = float(dy*s)/u_norm
        
        print "(%3.4f,%3.4f) --> (%3.4f,%3.4f) @ %3.4f p/s" % (xo,yo,x,y,
                                                            self.speed)
        

        self.do(MoveBy((dxt,dyt),dt))
        #self.position = (x + dxt,y+dyt)
        
        #angle = tan(dy/dx) / pi * 180
    
    
    def spin(thisBug,t=1):
        """
        Spins the current bug around in t seconds. The variable thisBug would
        normally be called self. However this is not required.
        """
        thisBug.do( Rotate(360,t) )
        
        
    def moveRandom(thisBug):
        x = random.randint(1,10)
        y = random.randint(1,10)
        spin = random.randint(1,100)
        thisBug.do( MoveBy((x,y),1) | Rotate( spin, 1))
        
        
    def doDamage(self,damage):
        self.health = self.health - damage
        if self.health <= 0:
            self.visible = False
            return True
            #self.parent.remove(self)
            
            
    def __repr__(self):
        x,y = self.position
        return "<Bug @(%d,%d) with HP = %d" % (x,y,self.health)
        
    