# -*- coding: utf-8 -*-
"""
This module contains the main game scene.
"""
import cocos
from cocos.actions import *
import data
import pyglet

from gamemap import GameMap
from hudlayer import HudLayer
from gunlayer import GunLayer

# Importing the layers.

from maplayer import MapLayer



class GameScene(cocos.scene.Scene):
    def __init__(self,*args,**kwds):
        #cocos.scene.Scene.__init__(self,*args,**kwds)
        
        self.gameMap = GameMap()
        
        self.hudLayer = HudLayer(self.gameMap)
        self.mapLayer = MapLayer(self.gameMap)
        self.gunLayer = GunLayer(self.gameMap)

        cocos.scene.Scene.__init__(self,self.mapLayer,
                                        self.hudLayer,
                                        self.gunLayer)
        
        
        # NB: This is required for events to work on a specific scene!!!
        self.enable_handlers(True)
