# -*- coding: utf-8 -*-
'''Game main module.

Contains the entry point used by the run_game.py script.

Feel free to put all your game code here, or in other modules in this "gamelib"
package.
'''

import data

# cocos2d is the main game/graphics library we are going to use. It supports
# openGL acceleration which is nice.
import cocos
from cocos.actions import *



# Importing the scenes

from gamescene import GameScene
from intro import Background
from mapsprite import MapSprite


class BugzoomIntro(cocos.layer.ColorLayer):
    is_event_handler = True
    def __init__(self,*args):
        cocos.layer.ColorLayer.__init__(self,*args)
    
        #Add intro background
        
        grass = MapSprite('grassvector.png',position=(350,150), opacity = 75);
        self.add(grass,z = 1)
        
        getoff = MapSprite('getoff.png',position=(320,240))
        self.add(getoff)
        
        # Also now going to add a sprite to the layer.
        stinkBug = cocos.sprite.Sprite(data.loadImage('stink_bug.png'),scale = 6)
        stinkBug.position = 400,240
        
        # The z = 1, makes the bug be on a layer one higher than the text.
        self.add(stinkBug, z = 1)

        scale = ScaleBy(0.03,duration = 4)
        #label.do(Repeat( scale + Reverse(scale)))
        stinkBug.do(scale)
        
        grumpyMan = cocos.sprite.Sprite(data.loadImage('grumpy.png'),scale = 0.5)
        grumpyMan.position = 653,240
        self.add(grumpyMan,z = 2)
        move = MoveTo((-100,240),duration = 3)
        delay = Delay(4)
        grumpyMan.do(delay + move)
        stinkBug.do(delay + move)
        
    def on_mouse_press(self,*args):
        gameScene = GameScene()
        cocos.director.director.push(gameScene)
        
def main():
    cocos.director.director.init()
    
    introLayer = BugzoomIntro(255,255,255,255)
    introScene = cocos.scene.Scene(introLayer)
    introScene.enable_handlers(True)
    #gameScene = GameScene()
    cocos.director.director.run(introScene)
if __name__ == "__main__": main()