# -*- coding: utf-8 -*-



import cocos
from cocos.actions import *
import data
import pyglet
import math
import AStar

from mapsprite import MapSprite
from bugsprite import BugSprite
from buildingsprite import BuildingSprite
from math import *
from time import time
from random import randint

# Import the numpy array type to aid in calculation.
from numpy import array,zeros,sqrt

class MapLayer(cocos.layer.Layer):
    """
    MapLayer is where the main logic of the game is going to be.
    """
    def __init__(self,gameMap):
        """
        This function is called when the layer is CREATED.
        """
        super(MapLayer, self ).__init__()
        
        # Creating a reference to the gameMap object.
        self.gameMap = gameMap
        
        
        # Here im just creating the map background.
        # TODO: We should change the map background image to be *exactly* 
        #       640 x 480. For performance issues.
        background = MapSprite('lawnmap.jpg',position=(320,240))
        background.makeSize(640,480)
        self.add(background,z=-1)
        
        
	
	
	# Just creating a dummy bug, to display on the map.
        #bug1 = BugSprite('stink_bug_2.png',position=(10,200),scale=0.05, rotation=90)
        #bug2 = BugSprite('stink_bug_2.png',position=(40,10),scale=0.05, rotation=90)
        for i in range(1):
            bug = BugSprite('stink_bug_2.png',position=(randint(1,20),
                            randint(1,400)),scale=0.05,
                            rotation=90)
            self.gameMap.addBug(bug)
            self.add(bug)
            if i == 0:
                bug.position = (100,100)
        #bug2.visible = False
	
	
	
        
        # Adding the bug to the map.
        #self.gameMap.addBug(bug1)
        #self.gameMap.addBug(bug2)
        
        # Getting a list of bugs and adding them to the current layer.
        #bugs = self.gameMap.getBugs()
        #for b in bugs: 
        #    self.add( b )


	
	#Find the inital path for the bugs to follow
        #gameMap.findPathlines(30,24,640,480,[10,200],[600,200])
        self.gameMap.findMainpath()
        self.gameMap.updateBugs()




        
	## Going to try and make the bugs move randomly.
	#self.schedule_interval(self.moveBugsRandomly,1)
        
        
        
        ##tempoarry pathfinding call
        #f = lambda a: gameMap.findPathlines(30,30,640,480,[10,400],[600,200])
        #self.schedule_interval(f,1)
        
        
        
        
        #Update bug movement.
        self.time=0;
        self.schedule_interval(self.updateBugs,1./10)
        self.schedule_interval(self.addBugs,30)



	
    def moveBugsRandomly(self,dt):
        bugs = self.gameMap.getBugs()
        for b in bugs:
            b.moveRandom()



    def addBugs(self,dt):
        ri = randint(1,10)
        for i in range(ri):
            #bug = BugSprite()
            bug = BugSprite('stink_bug_2.png',
                            position=(randint(1,20),
                            randint(1,450)),
                            scale=0.05,
                            rotation=90)
            bug.setScaling(self.gameMap.bugScale * 10./ri)
            self.add(bug)
            self.gameMap.addBug(bug)
        self.gameMap.bugScale *= 1.5
            
    
    def updateBugs(self,dt):
        #bugs = self.gameMap.getBugs()
        gameMap = self.gameMap
        self.time += dt
        bugsEnd = []
        if self.time>10:
            bugs = self.gameMap.getBugs()
            path = self.gameMap.path
            lenPath = len(path)
            
            if path == []: return #Ugly hack to prevent failure.
            for b in bugs:
                if b.followMainPath:
                    x,y = b.position
                    target = path[int(b.mainPathIndex)]
                    if target == gameMap.coordToIndex(x,y):
                        b.mainPathIndex += 1
                
                    dx,dy = gameMap.indexToCenter(target)
                    b.moveTo(dx,dy,dt)
                    #b.do(MoveTo((dx,dy),20*dt))
                    if b.mainPathIndex >= lenPath:
                        # Bug has reached the end.
                        bugsEnd.append(b)
                else:
                    # Bug first need to get on the main path.
                    x,y = b.position
                    target = b.ownPath[int(b.ownPathIndex)]
                    current = gameMap.coordToIndex(x,y)
                    if current in path:
                        b.followMainPath = True
                        b.mainPathIndex = path.index(current)
                    elif target == gameMap.coordToIndex(x,y):
                        b.ownPathIndex += 1
                        
                    dx,dy = gameMap.indexToCenter(target)
                    #b.do(MoveTo((dx,dy),20*dt))
                    b.moveTo(dx,dy,dt)
        
        for b in bugsEnd:
            self.gameMap.hp -= b.health / 4
            self.gameMap.removeBug(b)
            self.remove(b)
            self.gameMap.status()
#            if len(bugs)>0:
#                for b in bugs:
#                    x,y = b.position
#                    norm = [];
#                    for c in path:
#                        xpath = c[0]
#                        ypath = c[1]
#                        norm.append(sqrt(((xpath)-(x))**2 + ((ypath) -(y))**2))
#                    index = norm.index(min(norm))
#                    x_index = path[index][0]
#                    y_index = path[index][1]
#                    if abs(x_index-x) < 10 and abs(y_index - y)<10:
#                        index +=1;
#                        x_index = path[index][0]
#                        y_index = path[index][1]
#                    b.do(MoveTo([x_index , y_index],dt*20))
                    
                        
                        
                        
                    
                    
                    
                    
                    
                    #x_to = self.gameMap.mainpath[1][0]
                    #y_to = self.gameMap.mainpath[1][1]
                    #if abs(x-x_to)<30 and abs(y-y_to)<30:
                        #self.gameMap.path.pop(0)
                        #x_to = self.gameMap.mainpath[1][0]
                        #y_to = self.gameMap.mainpath[1][1]
                    #Dx = self.gameMap.mainpath[1][0] - self.gameMap.mainpath[0][0]
                    #Dy = self.gameMap.mainpath[1][1] - self.gameMap.mainpath[0][1]
                    #degree = tan(float(Dy)/float(Dx+1e-2))/pi*180
                    
                    #b.do(MoveTo([x_to , y_to],1))
                    #b.do(RotateTo(90-degree,0.01))
            
            
            
        return[]
        

